package eu.eudat.publicapi.configurations;

import eu.eudat.models.data.security.Principal;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;

import java.util.Collections;

@Configuration
public class SwaggerConfiguration {

   // private static final TypeResolver resolver = new TypeResolver();

    @Bean
    public Docket api() {
        return new Docket(DocumentationType.SWAGGER_2)
                .select()
                .apis(RequestHandlerSelectors.basePackage("eu.eudat.publicapi.controllers"))
                .paths(PathSelectors.regex("/api/public/(dmps|datasets)/?.*"))
                .build().apiInfo(apiInfo())//.ignoredParameterTypes(Principal.class)
                .useDefaultResponseMessages(false);
    }

    private ApiInfo apiInfo() {
        return new ApiInfo(
                "OpenDMP public API",
                "Argos public API.",
                "1.0",
                "https://argos.openaire.eu/terms-and-conditions",
                new Contact("Argos", "https://argos.openaire.eu/", "argos@openaire.eu "),
                null, null, Collections.emptyList());
    }
}
